#Put here the path where you have put the R codes, for example:

setwd("/Users/Tianying/Documents/My/notes/689/code/Matlab/programs/r")


source("PI_deconvUknownth4.r")
source("rlap.r")
source("outerop.r")
source("fdecUknown.r")
source("CVdeconv.r")
source("truedens.r")
source("fDKDE.r")
#Author: Aurore Delaigle
#This code illustrates how to use the functions for computing the deconvolution kernel density estimator and its bandwidths

#Noise to signal ratio=varU/varX
NSR=0.2

#Sample size
n=200

mu1=-3;
mu2=2;
sig1=1;
sig2=1;

#Generate data from a normal mixture
X=rnorm(n,mu1,sig1);
X2=rnorm(n,mu2,sig2);

pmix=0.75;
tmp=matrix(runif(n,0,1),nrow=1,ncol=n,byrow=T);
X[which(tmp<pmix)]=X2[which(tmp<pmix)];
errortype="Lap";
#normal case  
if (errortype=="norm")
{sigU=sqrt(NSR*var(X));
 U=rnorm(n,0,sigU);
 varU=sigU^2;}

#Laplace case
if (errortype=="Lap")
{sigU=sqrt(NSR*var(X)/2);
 varU=2*sigU^2;
 U=rlap(sigU,1,n);}

#Contaminated data
W=as.vector(X+U);
outcome<-fDKDE(W,errortype,NSR,n,varU,sigU)

