fDKDEheterosc<-function(W,errortype,sigmaj,n)
{

#Grid where to estimate the true density
xx=seq(-8,7,0.1);
dx=xx[2]-xx[1];

#Plot the true density
plot(xx,truedens(xx),'l',col='red',xlab="",ylab="")


#PI bandwidth of Delaigle and Gijbels
hPI=PI_deconvUknownth4het(W,errortype,sigmaj);

#DKDE estimator without rescaling (density does not integrate exactly to 1)
y=fdecUknownhet(xx,W,hPI,errortype,sigmaj);

#With rescaling: here xx must be equispaced and must cover the range where the estimated density is significantly non zero
y2=fdecUknownhet(xx,W,hPI,errortype,sigmaj,dx);

lines(xx,y,col='black')
lines(xx,y2,col='green')


#Compare with the naive KDE estimator that ignores the error (using normal reference bandwidth and standard normal kernel)
h=1.06*sqrt(var(W))*n^(-1/5);
xout=outerop(xx,W,"-");

fnaive=apply(dnorm(xout,0,h),1,sum)/n;

lines(xx,fnaive,col='cyan')
legend(x="topright",legend=c("true f", "fdec, hPI", "fdec rescaled, hPI",  "naive estimator, hNR"),col=c("red","black","green","cyan"),lty=c(1,1,1,1),cex=0.73)


outcome<-list(hPI,y,y2,h,fnaive)
names(outcome)<-c('PI_bandwidth','DKDE_nonrescaled','DKDE_rescaled','normal_bandwidth','naive_KDE')
return (outcome)
}
