####This is a example for R package "fDKDEheterosc"
install.packages("~/Documents/My/notes/689/code/Matlab/programs/R_MEM_Tianying/R_package/fDKDEheterosc_1.0.tar.gz",repos=NULL,type="source")
library("fDKDEheterosc")

#Sample size
n=200

mu1=-3;
mu2=2;
sig1=1;
sig2=1;

#Generate data from a normal mixture
X=rnorm(n,mu1,sig1);
X2=rnorm(n,mu2,sig2);

pmix=0.75;
tmp=matrix(runif(n,0,1),nrow=1,ncol=n,byrow=T);
X[which(tmp<pmix)]=X2[which(tmp<pmix)];

#Specify error distributions (normal or Laplace in this case) and generate data from these error distributions
errortype="norm";
sigU=0.6;
#Parameters of the Laplace distribution (one parameter oer observation, so sigmaj is of length n)
sigmaj=sigU*sqrt(1.0+(1:n)/n)*sqrt(0.5);
if (errortype=="norm")
{#normal case  
  U=rep(1,n);
  for (i in 1:n)
    U[i]=rnorm(1,0,sigmaj[i]);}


if (errortype=="Lap")
{#Laplace case
  U=rep(1,n);
  for (i in 1:n)
    U[i]=rlap(sigmaj[i],1,1);}

#Contaminated data
W=as.vector(X+U);
outcome<-fDKDEheterosc(W,errortype,sigmaj,n)
